## cgreen 1.3.0

=== CMakeLists.txt ===
# Required cmake version
cmake_minimum_required(VERSION 2.8.5)

project(cgreen)

if (NOT(CMAKE_MAJOR_VERSION LESS 3) AND APPLE)
  if(POLICY CMP0042)
    cmake_policy(SET CMP0042 NEW) # CMake 3.0 to use @rpath on MacOSX libraries
  endif()
endif()

find_package (Threads)

enable_testing()

# global needed variables
set(APPLICATION_NAME ${PROJECT_NAME})
set(APPLICATION_VERSION_MAJOR "1")
set(APPLICATION_VERSION_MINOR "3")
set(APPLICATION_VERSION_PATCH "0")

set(APPLICATION_VERSION ${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}${APPLICATION_VERSION_STATUS})
add_definitions(-DVERSION="${APPLICATION_VERSION}")

set(LIBRARY_VERSION ${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH})
set(LIBRARY_SOVERSION ${APPLICATION_VERSION_MAJOR})

include(GNUInstallDirs)

if(MSVC)
  # these have sensible defaults on other platforms
  set(CMAKE_INSTALL_BINDIR ".")
  set(CMAKE_INSTALL_LIBDIR ".")
endif(MSVC)

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH
  ${PROJECT_SOURCE_DIR}/cmake/Modules
)

# add definitions
include(DefineCMakeDefaults)
include(DefineCompilerFlags)
include(DefineOptions.cmake)
include(DefineCPackConfig)

# add macros
include(MacroAddPlugin)
include(MacroCopyFile)

# Generate gitrevision.h if Git is available and the .git directory is found.
find_program(GIT_EXECUTABLE git DOC "Git version control")
mark_as_advanced(GIT_EXECUTABLE)

# Find path to .git/logs/HEAD so that the gitrevision.h generation will only
# happen on new commits. This is done from $PROJECT_SOURCE_DIR because git rev-parse
# doesn't always return an absolute path so need to use get_filename_component()
# to get a cross-platform `readlink -f $(git rev-parse --git-path logs/HEAD)`
execute_process(
  COMMAND ${GIT_EXECUTABLE} rev-parse --git-path logs/HEAD
  WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
  OUTPUT_VARIABLE GITDIR
  OUTPUT_STRIP_TRAILING_WHITESPACE
  )
get_filename_component(GITDIR "${GITDIR}" ABSOLUTE)

# config.h checks
include(ConfigureChecks.cmake)
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# check subdirectories
add_subdirectory(doc)
add_subdirectory(include)
add_subdirectory(src)
if (UNIX OR MSYS)
  # reflective runner only supported on UNIX/binutils platforms
  add_subdirectory(tools)
endif(UNIX OR MSYS)
# add_subdirectory(samples)

if (CGREEN_WITH_UNIT_TESTS)
  include(MacroAddUnitTest)
  include(MacroAddTest)
  add_subdirectory(tests)
  if (UNIX OR MSYS)
    # reflective runner only supported on UNIX/binutils platforms
    add_subdirectory(tools/tests)
  endif(UNIX OR MSYS)
endif (CGREEN_WITH_UNIT_TESTS)

# add custom 'check' target to run tests with output-on-failure
if (CMAKE_CONFIGURATION_TYPES)
    add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND}
        --force-new-ctest-process --output-on-failure
        --build-config "$<CONFIGURATION>")
else()
    add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND}
        --force-new-ctest-process --output-on-failure)
endif()

IF(CGREEN_INTERNAL_WITH_GCOV)
  IF(CMAKE_C_COMPILER_ID STREQUAL GNU)
    include(CodeCoverage)
    add_custom_target(coverage
        COMMAND ${LCOV_PATH} --directory . --capture --output-file coverage.info
        COMMAND ${LCOV_PATH} --remove coverage.info '/usr/*' -o coverage.info
        COMMAND ${GENHTML_PATH} -o coverage coverage.info
    )
  ENDIF()
ELSE()
  add_custom_target(coverage
      COMMAND echo "WARNING: Configure CGREEN_INTERNAL_WITH_GCOV to get coverage")
ENDIF()


#### Begin cgreen package configuration steps. ####

# After install other CMake projects can
# use find_package( cgreen )

set( CONFIG_INSTALL_DIR
        "${CMAKE_INSTALL_LIBDIR}/cmake/${APPLICATION_NAME}" )

set( PROJECT_CONFIG_IN
        "${CMAKE_CURRENT_SOURCE_DIR}/cgreen-config.cmake.in" )

set( VERSION_CONFIG_IN
        "${CMAKE_CURRENT_SOURCE_DIR}/cgreen-config-version.cmake.in" )

set( PROJECT_CONFIG
        "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/cgreen-config.cmake" )

set( VERSION_CONFIG
        "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/cgreen-config-version.cmake" )

configure_file( ${PROJECT_CONFIG_IN}
        "${PROJECT_CONFIG}" @ONLY )

configure_file( ${VERSION_CONFIG_IN}
        "${VERSION_CONFIG}" @ONLY )

install(FILES
        "${PROJECT_CONFIG}" "${VERSION_CONFIG}"
        DESTINATION
        "${CONFIG_INSTALL_DIR}" )

#### End cgreen package configuration steps. ####

=== Makefile ===
# This Makefile ensures that the build is made out of source in a
# subdirectory called 'build' If it doesn't exist, it is created.
#
# This Makefile also contains delegation of the most common make commands
#
# If you have cmake installed you should be able to do:
#
#	make
#	make test
#	make install
#	make package
#
# That should build Cgreen in the build directory, run some tests,
# install it locally and generate a distributable package.

all: build/Makefile
	cd build; make

.PHONY:debug
debug: build
	cd build; cmake -DCMAKE_BUILD_TYPE:string=Debug ..; make

32bit: build
	-rm -rf build; mkdir build; cd build; cmake -DCMAKE_C_FLAGS="-m32" -DCMAKE_CXX_FLAGS="-m32" ..; make

.PHONY:test
test: build/Makefile
	cd build; make check

.PHONY:clean
clean: build/Makefile
	cd build; make clean

.PHONY:package
package: build/Makefile
	cd build; make package

.PHONY:install
install: build
ifeq ($(OS),Msys)
  # Thanks to https://stackoverflow.com/a/46027426/204658
  cd build; make install DESTDIR=/
else
	cd build; make install
endif

# This is kind of a hack to get a quicker and clearer feedback when
# developing Cgreen by allowing 'make unit'. Must be updated when new
# test libraries or output comparisons are added.

# Find out if 'uname -o' works, if it does - use it, otherwise use 'uname -s'
UNAMEOEXISTS=$(shell uname -o &>/dev/null; echo $$?)
ifeq ($(UNAMEOEXISTS),0)
  OS=$(shell uname -o)
else
  OS=$(shell uname -s)
endif

# Set prefix and suffix for shared libraries depending on platform
ifeq ($(OS),Darwin)
	LDPATH=DYLD_LIBRARY_PATH=$(PWD)/build/src
	PREFIX=lib
	SUFFIX=.dylib
else ifeq ($(OS),Cygwin)
	LDPATH=PATH=$(PWD)/build/src:"$$PATH"
	PREFIX=cyg
	SUFFIX=.dll
else ifeq ($(OS),Msys)
	LDPATH=PATH=$(PWD)/build/src:"$$PATH"
	PREFIX=lib
	SUFFIX=.dll
else
	LDPATH=LD_LIBRARY_PATH=$(PWD)/build/src
	PREFIX=lib
	SUFFIX=.so
endif

DIFF_TOOL=../../tools/cgreen_runner_output_diff
XML_DIFF_TOOL=../../tools/cgreen_xml_output_diff
DIFF_TOOL_ARGUMENTS = $(1)_tests \
	../../tests \
	$(1)_tests.expected

unit: build-it
	SOURCEDIR=$$PWD/tests/ ; \
	cd build ; \
	$(LDPATH) tools/cgreen-runner -c `find tests -name $(PREFIX)cgreen_c_tests$(SUFFIX)` ; \
	r=$$((r + $$?)) ; \
	$(LDPATH) tools/cgreen-runner -c `find tests -name $(PREFIX)cgreen_cpp_tests$(SUFFIX)` ; \
	r=$$((r + $$?)) ; \
	$(LDPATH) tools/cgreen-runner -c `find tools/tests -name $(PREFIX)cgreen_runner_tests$(SUFFIX)` ; \
	r=$$((r + $$?)) ; \
	cd tests ; \
	$(LDPATH) $(XML_DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,xml_output) ; \
	r=$$((r + $$?)) ; \
	$(LDPATH) $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,assertion_messages) ; \
	r=$$((r + $$?)) ; \
	$(LDPATH) $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,mock_messages) ; \
	r=$$((r + $$?)) ; \
	$(LDPATH) $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,constraint_messages) ; \
	r=$$((r + $$?)) ; \
	$(LDPATH) $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,custom_constraint_messages) ; \
	r=$$((r + $$?)) ; \
	$(LDPATH) $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,ignore_messages) ; \
	r=$$((r + $$?)) ; \
	$(LDPATH) CGREEN_PER_TEST_TIMEOUT=1 $(DIFF_TOOL) $(call DIFF_TOOL_ARGUMENTS,failure_messages) ; \
	r=$$((r + $$?)) ; \
	exit $$r

.PHONY: doc
doc: build
	cd build; cmake -DCGREEN_WITH_HTML_DOCS:bool=TRUE ..; make; cmake -DCGREEN_WITH_HTML_DOCS:bool=False ..; echo open $(PWD)/build/doc/cgreen-guide-en.html

pdf: build
	cd build; cmake -DCGREEN_WITH_PDF_DOCS:bool=TRUE ..; make; cmake -DCGREEN_WITH_PDF_DOCS:bool=False ..; echo open $(PWD)/build/doc/cgreen-guide-en.pdf

chunked: doc
	asciidoctor-chunker build/doc/cgreen-guide-en.html -o docs
	echo open $(PWD)/docs/index.html

.PHONY:valgrind
valgrind: build-it
	> valgrind.log
	for lib in `ls build/tests/$(PREFIX)*_tests$(SUFFIX)` ; \
	do \
		LD_LIBRARY_PATH=build/src valgrind --leak-check=full build/tools/cgreen-runner $$lib >> valgrind.log 2>&1 ; \
	done
	grep " lost:" valgrind.log | grep -v " 0 bytes" | wc -l



############# Internal

build-it: build/Makefile
	make -C build

build:
	mkdir build

build/Makefile: build
ifeq ($(OS),Msys)
	# Thanks to https://stackoverflow.com/a/46027426/204658
	cd build; cmake -G"MSYS Makefiles" -DCMAKE_INSTALL_PREFIX=/usr/local ..
else
	cd build; cmake ..
endif

.SILENT:

=== doc/CMakeLists.txt ===
FIND_PACKAGE(Asciidoctor)

SET(ASCIIDOC_CONFFILE "${PROJECT_SOURCE_DIR}/doc/cgreen_asciidoc.conf")

OPTION(CGREEN_WITH_HTML_DOCS "with HTML output" FALSE)
OPTION(CGREEN_WITH_PDF_DOCS "with PDF output" FALSE)

IF (CGREEN_WITH_HTML_DOCS AND NOT ASCIIDOCTOR_FOUND)
  MESSAGE(FATAL_ERROR "Can't produce HTML without 'asciidoctor'")
ENDIF (CGREEN_WITH_HTML_DOCS AND NOT ASCIIDOCTOR_FOUND)

IF (CGREEN_WITH_PDF_DOCS AND NOT ASCIIDOCTORPDF_FOUND)
  MESSAGE(FATAL_ERROR "Can't produce PDF without 'asciidoctor-pdf'")
ENDIF (CGREEN_WITH_PDF_DOCS AND NOT ASCIIDOCTORPDF_FOUND)

IF(CGREEN_WITH_HTML_DOCS OR CGREEN_WITH_PDF_DOCS)
  FILE(GLOB _docfiles *.asciidoc)
  FOREACH(_file ${_docfiles})
    GET_FILENAME_COMPONENT(_file_we ${_file} NAME_WE)
    SET(_in "${_file_we}")
    IF (CGREEN_WITH_HTML_DOCS)
      SET(_out "${_file_we}.html")
      ADD_CUSTOM_COMMAND(
        OUTPUT "${_out}-html"
        COMMAND ${ASCIIDOCTOR_EXECUTABLE}
        -a VERSION=${APPLICATION_VERSION}
        -o ${_out} ${_file}
        DEPENDS ${_file}
        COMMENT "asciidoctor ${_in}"
      )
      ADD_CUSTOM_TARGET(${_in}-html ALL echo
        DEPENDS "${_out}-html"
      )
    ENDIF (CGREEN_WITH_HTML_DOCS)
    IF (CGREEN_WITH_PDF_DOCS)
      SET(_out "${_file_we}.pdf")
      ADD_CUSTOM_COMMAND(
        OUTPUT "${_out}-pdf"
        COMMAND ${ASCIIDOCTORPDF_EXECUTABLE}
        -a toc
        -a VERSION=${APPLICATION_VERSION}
        -a docinfo -o ${_out} ${_file}
        DEPENDS ${_file}
        COMMENT "asciidoctor-pdf ${_in}"
      )
      ADD_CUSTOM_TARGET(${_in}-pdf ALL echo
        DEPENDS "${_out}-pdf"
      )
    ENDIF (CGREEN_WITH_PDF_DOCS)
  ENDFOREACH(_file)
ENDIF(CGREEN_WITH_HTML_DOCS OR CGREEN_WITH_PDF_DOCS)

IF(UNIX)
    set(MANPAGES man)
    INSTALL(DIRECTORY ${MANPAGES} DESTINATION share/)
ENDIF(UNIX)

=== samples/CMakeLists.txt ===
include_directories(${CGREEN_PUBLIC_INCLUDE_DIRS} ${PROJECT_BINARY_DIR})
add_executable(sample sample.c)

=== src/CMakeLists.txt ===
# Generate gitrevision.h if Git is available and the .git directory is found.
# NOTE: $GITDIR is determined in top-level CMakeLists.txt
if (GITDIR AND GIT_EXECUTABLE)
  # Create gitrevision.h
  add_custom_command(OUTPUT ${PROJECT_SOURCE_DIR}/gitrevision.h
    COMMAND ${CMAKE_COMMAND} -E echo_append "#define GITREVISION \"" > ${PROJECT_SOURCE_DIR}/gitrevision.h.tmp
    COMMAND ${GIT_EXECUTABLE} describe --tags --always --abbrev=7 --dirty=-modified >> ${PROJECT_SOURCE_DIR}/gitrevision.h.tmp
    COMMAND ${CMAKE_COMMAND} -E echo_append "\"" >> ${PROJECT_SOURCE_DIR}/gitrevision.h.tmp
    COMMAND sed -e N -e "s/\\n//g" ${PROJECT_SOURCE_DIR}/gitrevision.h.tmp > ${PROJECT_SOURCE_DIR}/gitrevision.h
    COMMAND ${CMAKE_COMMAND} -E remove -f ${PROJECT_SOURCE_DIR}/gitrevision.h.tmp
    DEPENDS ${GITDIR}
    VERBATIM
    COMMENT "-- Generating gitrevision.h"
    )
else()
  # No version control
  # e.g. when the software is built from a source tarball
  message(WARNING "-- Unable to find git. Setting git revision to 'unknown'.")
  add_custom_command(OUTPUT ${PROJECT_SOURCE_DIR}/gitrevision.h
    COMMAND ${CMAKE_COMMAND} -E echo "#define GITREVISION \"unknown\"" > ${PROJECT_SOURCE_DIR}/gitrevision.h
    VERBATIM
    )
endif()


set(CGREEN_PUBLIC_INCLUDE_DIRS
  ${PROJECT_SOURCE_DIR}/
  ${PROJECT_SOURCE_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIR}
  CACHE INTERNAL "cgreen public include directories"
)

set(CGREEN_PRIVATE_INCLUDE_DIRS
  ${PROJECT_BINARY_DIR}
)

if (MSVC)
  LIST(APPEND CGREEN_PRIVATE_INCLUDE_DIRS
    ${PROJECT_SOURCE_DIR}/../include/cgreen/internal/windows_headers
  )
endif(MSVC)

set(CGREEN_SHARED_LIBRARY
  cgreen_shared
  CACHE INTERNAL "cgreen shared library"
)

if (WIN32 AND NOT CYGWIN)
  set(CGREEN_LINK_LIBRARIES
    winmm.lib
  )
endif(WIN32 AND NOT CYGWIN)

set(cgreen_SRCS
  assertions.c
  boxed_double.c
  breadcrumb.c
  cgreen_time.c
  cgreen_value.c
  constraint.c
  constraint_syntax_helpers.c
  cute_reporter.c
  cdash_reporter.c
  messaging.c
  message_formatting.c
  mocks.c
  parameters.c
  reporter.c
  runner.c
  string_comparison.c
  suite.c
  text_reporter.c
  utils.c
  vector.c
  xml_reporter.c
)

if (MSYS)
  # Msys2 is difficult since it really is three different "OS":es, Msys native, W32 and W64
  # To get somewhere, let's use the native Msys2, which actually is Cygwin/UNIX.
  LIST(APPEND cgreen_SRCS
    posix_cgreen_pipe.c
    posix_cgreen_time.c
    posix_runner_platform.c
  )
elseif (UNIX OR CYGWIN)
  LIST(APPEND cgreen_SRCS
    posix_cgreen_pipe.c
    posix_cgreen_time.c
    posix_runner_platform.c
  )
elseif(WIN32)
 LIST(APPEND cgreen_SRCS
    win32_cgreen_pipe.c
    win32_cgreen_time.c
    win32_runner_platform.c
  )
else()
  message(FATAL_ERROR "Cgreen can currently only be compiled for Msys2, Cygwin, MacOSX and Windows.")
endif()
SET_SOURCE_FILES_PROPERTIES(${cgreen_SRCS} PROPERTIES LANGUAGE C)

set(cgreen_SRCS ${cgreen_SRCS}
  cpp_assertions.cpp
  cpp_constraint.cpp
)
SET_SOURCE_FILES_PROPERTIES(cpp_assertions.cpp cpp_constraint.cpp PROPERTIES LANGUAGE CXX )

include_directories(
  ${CGREEN_PUBLIC_INCLUDE_DIRS}
  ${CGREEN_PRIVATE_INCLUDE_DIRS}
)

### cgreen
set(CGREEN_LIBRARY_NAME cgreen)
add_library(${CGREEN_SHARED_LIBRARY} SHARED ${cgreen_SRCS} ${PROJECT_SOURCE_DIR}/gitrevision.h)

target_link_libraries(
  ${CGREEN_SHARED_LIBRARY}
  ${CGREEN_LINK_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
  ${MATH_LIB}
  ${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES}
)

set_target_properties(
  ${CGREEN_SHARED_LIBRARY}
    PROPERTIES
      VERSION
        ${LIBRARY_VERSION}
      SOVERSION
        ${LIBRARY_SOVERSION}
      OUTPUT_NAME
        ${CGREEN_LIBRARY_NAME}
)

install(
  TARGETS ${CGREEN_SHARED_LIBRARY}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  DESTINATION ${CMAKE_INSTALL_BINDIR}
  COMPONENT libraries
)

if (CGREEN_WITH_STATIC_LIBRARY)

  set(CGREEN_STATIC_LIBRARY
    cgreen_static
    CACHE INTERNAL "cgreen static library"
  )

  add_library(${CGREEN_STATIC_LIBRARY} STATIC ${cgreen_SRCS})

  target_link_libraries(${CGREEN_STATIC_LIBRARY}
    ${CGREEN_LINK_LIBRARIES}
    ${MATH_LIB}
    ${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES}
  )

  set_target_properties(
    ${CGREEN_STATIC_LIBRARY}
      PROPERTIES
        VERSION
          ${LIBRARY_VERSION}
        SOVERSION
          ${LIBRARY_SOVERSION}
        OUTPUT_NAME
          ${CGREEN_LIBRARY_NAME}
  )

  install(
    TARGETS ${CGREEN_STATIC_LIBRARY}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT libraries
  )
endif(CGREEN_WITH_STATIC_LIBRARY)

=== tests/CMakeLists.txt ===
set(CGREEN_TEST_INCLUDE_DIRS
  ${CGREEN_PUBLIC_INCLUDE_DIRS}
  ${CMAKE_CURRENT_BINARY_DIR}
)

check_include_file("sys/resource.h" HAVE_SYS_RESOURCE_H)
if (HAVE_SYS_RESOURCE_H)
  add_definitions(-DHAVE_SYS_RESOURCE_H)
endif(HAVE_SYS_RESOURCE_H)

if (MSVC)
  LIST(APPEND CGREEN_TEST_INCLUDE_DIRS
    ${PROJECT_SOURCE_DIR}/include/cgreen/internal/windows_headers
  )
endif(MSVC)


include_directories(${CGREEN_TEST_INCLUDE_DIRS})

# Dependency on our own library
if (CGREEN_WITH_STATIC_LIBRARY)
  set(CGREEN_LIBRARY ${CGREEN_STATIC_LIBRARY})
else ()
  set(CGREEN_LIBRARY ${CGREEN_SHARED_LIBRARY})
endif()


# C tests, library to use with runner, and a main program
# NOTE that some of these are "pure" unit tests which only
# need to work in C, since Cgreen's internal is C.
# Some others are actually testing user level functionality
# which must work both for C and C++ compiles.
# TODO: separate out those into separate dirs? Or just
# two lists of files, one which should go into C++ compilation
# too.
set(c_tests_library_SRCS
  assertion_tests.c
  breadcrumb_tests.c
  cdash_reporter_tests.c
  cgreen_value_tests.c
  constraint_tests.c
  cute_reporter_tests.c
  double_tests.c
  environment_variables_tests.c
  message_formatting_tests.c
  messaging_tests.c
  mocks_tests.c
  parameters_tests.c
  reflective_runner_no_teardown_tests.c
  reflective_tests.c
  text_reporter_tests.c
  unit_tests.c
  vector_tests.c
  xml_reporter_tests.c
)
SET_SOURCE_FILES_PROPERTIES(${c_tests_library_SRCS} PROPERTIES LANGUAGE C)

set(CGREEN_C_TESTS_LIBRARY
  cgreen_c_tests
  CACHE INTERNAL "cgreen shared library with tests for C"
)

add_library(${CGREEN_C_TESTS_LIBRARY} SHARED ${c_tests_library_SRCS})
target_link_libraries(${CGREEN_C_TESTS_LIBRARY} ${CGREEN_LIBRARY})

set(c_tests_SRCS
  all_c_tests.c
  ${c_tests_library_SRCS}
)
SET_SOURCE_FILES_PROPERTIES(${c_tests_SRCS} PROPERTIES LANGUAGE C)

set(TEST_TARGET_LIBRARIES ${CGREEN_LIBRARY})

# unit test with main program runner
macro_add_unit_test(test_cgreen_c "${c_tests_SRCS}" "${TEST_TARGET_LIBRARIES}")
macro_add_test(NAME test_cgreen_c_run_named_test COMMAND test_cgreen_c integer_one_should_assert_true)

# run them with cgreen-runner also
macro_add_test(NAME runner_test_cgreen_c COMMAND cgreen-runner -x TEST ./${CMAKE_SHARED_LIBRARY_PREFIX}${CGREEN_C_TESTS_LIBRARY}${CMAKE_SHARED_LIBRARY_SUFFIX})


# C++ tests, library to use with runner, and a main program
# NOTE that .cpp-versions should be links to .c-versions so we avoid duplication
# so we just use the same list and add the CPP-specific tests here
foreach(c_test_file ${c_tests_library_SRCS})
  string(REGEX REPLACE "\\.c" ".cpp" cpp_test_file ${c_test_file})
  list(APPEND cpp_tests_library_SRCS ${cpp_test_file})
endforeach()

set(cpp_tests_library_SRCS
  ${cpp_tests_library_SRCS}
  cpp_assertion_tests.cpp
  )

SET_SOURCE_FILES_PROPERTIES(${cpp_tests_library_SRCS} PROPERTIES LANGUAGE CXX)

set(CGREEN_CPP_TESTS_LIBRARY
  cgreen_cpp_tests
  CACHE INTERNAL "cgreen shared library with tests for C++"
)
add_library(${CGREEN_CPP_TESTS_LIBRARY} SHARED ${cpp_tests_library_SRCS})
target_link_libraries(${CGREEN_CPP_TESTS_LIBRARY} ${CGREEN_LIBRARY} ${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES})

set(cpp_tests_SRCS
  all_cpp_tests.cpp
  ${cpp_tests_library_SRCS}
)
SET_SOURCE_FILES_PROPERTIES(${cpp_tests_SRCS} PROPERTIES LANGUAGE CXX)

macro_add_unit_test(test_cgreen_cpp "${cpp_tests_SRCS}" "${TEST_TARGET_LIBRARIES}" ${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES})
macro_add_test(NAME test_cgreen_cpp_run_named_test COMMAND test_cgreen_cpp different_pointers_with_same_contents_should_assert_equal)
macro_add_test(NAME runner_test_cgreen_cpp COMMAND cgreen-runner -x TEST ./${CMAKE_SHARED_LIBRARY_PREFIX}${CGREEN_CPP_TESTS_LIBRARY}${CMAKE_SHARED_LIBRARY_SUFFIX})

# Temporary single CUT test library
# Maybe we should do this for all tests instead
# and then aggregate the DLL/so/dylibs instead...
# Then this might be possible to turn into a macro
# which could allow "add_runner_lib(text_reporter)"
foreach(case
    assertion
    breadcrumb
    cdash_reporter
    cgreen_value
    constraint
    cute_reporter
    double
    message_formatting
    messaging
    mocks
    parameters
    reflective
    reflective_runner_no_teardown
    text_reporter
    unit
    vector
    xml_reporter
  )
  set(${case}_tests_SRCS
      ${case}_tests.c
  )
  set(${case}_tests_library
      ${case}_tests
  )
  add_library(${${case}_tests_library} SHARED ${${case}_tests_SRCS})
  target_link_libraries(${${case}_tests_library} ${CGREEN_LIBRARY})
endforeach(case)


# Libraries for a set of output comparing tests to run with runner

set(constraint_messages_library constraint_messages_tests)
set(constraint_messages_library_SRCS constraint_messages_tests.c)
add_library(${constraint_messages_library} SHARED ${constraint_messages_library_SRCS})
target_link_libraries(${constraint_messages_library} ${CGREEN_LIBRARY})

set(custom_constraint_messages_library custom_constraint_messages_tests)
set(custom_constraint_messages_library_SRCS custom_constraint_messages_tests.c)
add_library(${custom_constraint_messages_library} SHARED ${custom_constraint_messages_library_SRCS})
target_link_libraries(${custom_constraint_messages_library} ${CGREEN_LIBRARY})

set(mock_messages_library mock_messages_tests)
set(mock_messages_library_SRCS mock_messages_tests.c)
add_library(${mock_messages_library} SHARED ${mock_messages_library_SRCS})
target_link_libraries(${mock_messages_library} ${CGREEN_LIBRARY})

set(failure_messages_library failure_messages_tests)
set(failure_messages_library_SRCS failure_messages_tests.c)
add_library(${failure_messages_library} SHARED ${failure_messages_library_SRCS})
target_link_libraries(${failure_messages_library} ${CGREEN_LIBRARY})

set(assertion_messages_library assertion_messages_tests)
set(assertion_messages_library_SRCS assertion_messages_tests.c)
add_library(${assertion_messages_library} SHARED ${assertion_messages_library_SRCS})
target_link_libraries(${assertion_messages_library} ${CGREEN_LIBRARY})

set(ignore_messages_library ignore_messages_tests)
set(ignore_messages_library_SRCS ignore_messages_tests.c)
add_library(${ignore_messages_library} SHARED ${ignore_messages_library_SRCS})
target_link_libraries(${ignore_messages_library} ${CGREEN_LIBRARY})

set(xml_output_library xml_output_tests)
set(xml_output_library_SRCS xml_output_tests.c)
add_library(${xml_output_library} SHARED ${xml_output_library_SRCS})
target_link_libraries(${xml_output_library} ${CGREEN_LIBRARY})

set(TEST_TARGET_LIBRARIES ${CGREEN_LIBRARY})

macro_add_test(
    NAME constraint_messsages
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
            constraint_messages_tests       # Name
            ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
            ${constraint_messages_library}.expected
)

macro_add_test(
    NAME custom_constraint_messsages
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
            custom_constraint_messages_tests       # Name
            ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
            ${custom_constraint_messages_library}.expected
)

macro_add_test(
    NAME mock_messsages
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
            mock_messages_tests             # Name
            ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
            ${mock_messages_library}.expected
)

macro_add_test(NAME failure_messages
    COMMAND env "CGREEN_PER_TEST_TIMEOUT=2" ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
            failure_messages_tests          # Name
            ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
            ${failure_messages_library}.expected
)

macro_add_test(NAME assertion_messages
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
            assertion_messages_tests        # Name
            ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
            ${assertion_messages_library}.expected
)

macro_add_test(NAME ignore_messages
    COMMAND env "CGREEN_PER_TEST_TIMEOUT=2" ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_runner_output_diff
            ignore_messages_tests           # Name
            ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
            ${ignore_messages_library}.expected
)

macro_add_test(NAME xml_output
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/cgreen_xml_output_diff
            xml_output_tests                # Name
            ${CMAKE_CURRENT_SOURCE_DIR}     # Where sources are
            ${xml_output_library}.expected
)

# add verification that all public api is available as it should
add_subdirectory(api)

=== tools/CMakeLists.txt ===
include_directories(${CGREEN_PUBLIC_INCLUDE_DIRS} ${PROJECT_BINARY_DIR})

set(RUNNER_SRCS
    cgreen-runner.c gopt.c gopt-errors.c runner.c discoverer.c test_item.c io.c)
set_source_files_properties(${RUNNER_SRCS} PROPERTIES LANGUAGE C)

add_executable(cgreen-runner ${RUNNER_SRCS})
target_link_libraries(cgreen-runner ${CGREEN_SHARED_LIBRARY} ${CMAKE_DL_LIBS})

install(TARGETS cgreen-runner
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(PROGRAMS cgreen-debug
  DESTINATION ${CMAKE_INSTALL_BINDIR})

=== tools/Makefile ===
# Makefile to run unit tests for cgreen-runner units
#
# We are using cgreen itself to test this but since the modules here
# might at some point get into the actual cgreen-runner there will be
# a clash when it loads the test library. So we will have to make the
# external symbols in the modules have other names when unittesting
# them using macro magic. The UNITTESTING preprocessor symbol will
# add the suffix '_unittesting' to externally, clashing symbols so
# that we can separate the once in the cgreen-runner that is running
# the tests, and the ones in the units being tested.

UNAMEOEXISTS=$(shell uname -o 1>&2 2>/dev/null; echo $$?)
ifeq ($(UNAMEOEXISTS),0)
  OS=$(shell uname -o)
else
  OS=$(shell uname -s)
endif

COMMONFLAGS = -g
CFLAGS = $(COMMONFLAGS) -Wall -Wextra -I../include -MMD -DUNITTESTING
ifneq ($(OS),Cygwin)
  CFLAGS+=-fPIC
endif

LDFLAGS = $(COMMONFLAGS)

LIBRARIES = -L../build/src -lcgreen

VPATH = ../src

ifeq ($(OS),Darwin)
	LD_PATH_NAME=DYLD_LIBRARY_PATH
else
	LD_PATH_NAME=LD_LIBRARY_PATH
endif

CGREEN_RUNNER = $(LD_PATH_NAME)=../build/src cgreen-runner


# Redirect to CMake build from top level
all:
	make --no-print-directory -C ..

# Use this if you want quick feed back in this directory
tests: unit_tests acceptance_tests

#----------------------------------------------------------------------
main: main.o discoverer_acceptance_tests.o discoverer.o test_item.o io.o utils.o
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBRARIES)

utils.o: ../src/utils.c

#----------------------------------------------------------------------
unit_tests: libdiscoverer_unit_tests.so
	$(CGREEN_RUNNER) $^

libdiscoverer_unit_tests.so: discoverer_unit_tests.o discoverer.o test_item.o
	$(CC) -shared -o $@ $^ $(LIBRARIES)

io.mocks : io.h
	../contrib/cgreen-mocker/cgreen-mocker.py -I../../pycparser-master/utils/fake_libc_include io.h > io.mocks

#----------------------------------------------------------------------
acceptance_tests: libdiscoverer_acceptance_tests.so
	$(CGREEN_RUNNER) $^

libdiscoverer_acceptance_tests.so: discoverer_acceptance_tests.o discoverer.o test_item.o io.o
	$(CC) -shared -o $@ $^ $(LIBRARIES)

#----------------------------------------------------------------------
clean:
	-rm *.o *.so

-include *.d

=== include/cgreen/CMakeLists.txt ===
set(cgreen_HDRS
  assertions.h
  boxed_double.h
  breadcrumb.h
  cdash_reporter.h
  cgreen.h
  cgreen_value.h
  constraint.h
  constraint_syntax_helpers.h
  cpp_assertions.h
  cpp_constraint.h
  cute_reporter.h
  legacy.h
  mocks.h
  string_comparison.h
  reporter.h
  runner.h
  suite.h
  text_reporter.h
  unit.h
  vector.h
)

install(
  FILES
    ${cgreen_HDRS}
  DESTINATION
    ${CMAKE_INSTALL_INCLUDEDIR}/${APPLICATION_NAME}
  COMPONENT
    headers
)

add_subdirectory(internal)

=== tests/api/CMakeLists.txt ===
# This subdirectory verifies that the user level api compiles using
# only the publiced includes by compiling test files refering to that
# api. Goal is to reference, and thus verify, the whole api so that
# unintended changes to the API gets noticed early.
#
# There is no need to run the tests...

include_directories(${CGREEN_PUBLIC_INCLUDE_DIRS})

set(api_SRCS
  core_api.c
  suites_without_context_api.c
  suites_with_context_api.c
)

set(CGREEN_API_TEST_LIBRARY
  cgreen_api
  CACHE INTERNAL "cgreen library of user level api verification source"
)

add_library(${CGREEN_API_TEST_LIBRARY} SHARED ${api_SRCS})

target_link_libraries(${CGREEN_API_TEST_LIBRARY} ${CGREEN_LIBRARY} ${CMAKE_THREAD_LIBS_INIT})

#macro_add_test(NAME api_compilation_test
#              COMMAND ${PROJECT_SOURCE_DIR}/tools/compare_test_output_to_expected
#                      ${PROJECT_BINARY_DIR}/tools                       # Where is cgreen-runner?
#                      $<TARGET_FILE_NAME:${CGREEN_API_TEST_LIBRARY}>  # Library to run
#                      ${PROJECT_SOURCE_DIR}                             # Remove lines with these from output
#                      ${CGREEN_API_TEST_LIBRARY}                      # Normalized library name
#                      ${CMAKE_CURRENT_SOURCE_DIR})                    # Where is the expected output?

=== tools/tests/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/..
    ${CGREEN_PUBLIC_INCLUDE_DIRS}
    ${CURRENT_BINARY_DIR})

set(CGREEN_RUNNER_TESTS_LIBRARY
  cgreen_runner_tests
  CACHE INTERNAL "cgreen-runner tests shared library"
)
set(RUNNER_TESTS_SRCS
  runnerTests.c
  ../discoverer.c
  ../io.c
  ../test_item.c)
add_library(${CGREEN_RUNNER_TESTS_LIBRARY} SHARED ${RUNNER_TESTS_SRCS})

target_link_libraries(${CGREEN_RUNNER_TESTS_LIBRARY} ${CGREEN_SHARED_LIBRARY} ${CMAKE_DL_LIBS})

SET(CGREEN_RUNNER_TESTS_LIBRARY "$<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests>")

# Due to some (of many) CMake irregularities to reference the test libraries
# we can't just use its CMake name variable, but have to look it up with
# some special attributes of the library:
#     $<TARGET_FILE_DIR:the_lib>/$<TARGET_FILE_NAME:the_lib>
#
macro_add_test(NAME cgreen_runner_unit_tests
  COMMAND cgreen-runner ${CGREEN_RUNNER_TESTS_LIBRARY})

macro_add_test(NAME cgreen_runner_usage
  COMMAND cgreen-runner --help)

macro_add_test(NAME cgreen_runner_quiet
  COMMAND cgreen-runner -q ${CGREEN_RUNNER_TESTS_LIBRARY})

macro_add_test(NAME cgreen_runner_verbose
  COMMAND cgreen-runner -v -C ${CGREEN_RUNNER_TESTS_LIBRARY})

macro_add_test(NAME cgreen_runner_version
  COMMAND cgreen-runner --version)

macro_add_test(NAME cgreen_runner_single_explicit_named_test
  COMMAND cgreen-runner $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests> Runner:can_match_test_name)

macro_add_test(NAME cgreen_runner_patternmatched_testnames
  COMMAND cgreen-runner $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests> Runner:can*)

macro_add_test(NAME cgreen_runner_patternmatched_testnames_in_patternmatched_context
  COMMAND cgreen-runner $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests> Run*:can*)

macro_add_test(NAME cgreen_runner_wildcarded_tests_in_named_context
  COMMAND cgreen-runner $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests> Runner:*)

macro_add_test(NAME cgreen_runner_wildcarded_tests_in_wildcarded_context
  COMMAND cgreen-runner $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests> *:*)

macro_add_test(NAME cgreen_runner_with_xml_reporter
  COMMAND cgreen-runner --xml TEST --suite cgreen_runner_tests $<TARGET_FILE_DIR:cgreen_runner_tests>/$<TARGET_FILE_NAME:cgreen_runner_tests>)

macro_add_test(NAME cgreen_runner_multiple_libraries
  COMMAND cgreen-runner ${CGREEN_RUNNER_TESTS_LIBRARY} ${CGREEN_RUNNER_TESTS_LIBRARY} ${CGREEN_RUNNER_TESTS_LIBRARY})

=== debian/changelog ===
cgreen (1.3.0-2) unstable; urgency=medium

  [ Alvin Chen ]
  * Fix endian issue of tests.
    - is_equal_to_* is not able to handle compare variable which length is
      longer than 1 byte on big-endian architecture. However it is still
      capable to work well while comparing on a one-byte basis.
      (Closes: #972220)
  * Disable fixfilepath in debian/rules
    - it triggers build failures when enabled. Thanks to Vagrant Cascadian
      <vagrant@reproducible-builds.org> (Closes: #972304)

 -- SZ Lin (林上智) <szlin@debian.org>  Thu, 12 Nov 2020 13:21:15 +0800

cgreen (1.3.0-1) unstable; urgency=medium

  * New upstream release
  * Bump debhelper compat to 13
  * Update install file
  * Remove patch files which are fixed by upstream
  * Add a patch file to fix file references package build path

 -- Alvin Chen <sonoma001@gmail.com>  Tue, 11 Aug 2020 01:38:38 -0400

=== debian/control ===
Source: cgreen
Section: libs
Priority: optional
Maintainer: Alvin Chen <sonoma001@gmail.com>
Uploaders: SZ Lin (林上智) <szlin@debian.org>
Build-Depends: cmake, ruby-asciidoctor-pdf, debhelper-compat (= 13)
Standards-Version: 4.5.0
Homepage: https://github.com/cgreen-devs/cgreen
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/cgreen
Vcs-Git: https://salsa.debian.org/debian/cgreen.git

Package: libcgreen1-dev
Section: libdevel
Architecture: any
Depends: libcgreen1 (=${binary:Version}), ${misc:Depends}
Description: Cgreen library - development files
 A modern unit test and mocking framework for C and C++. Cgreen features
    - fast build, clean code, highly portable
    - simple auto-discovery of tests
    - fluent, expressive and readable API
    - each test runs in isolation to prevent cross-test dependencies
    - built-in mocking for C, compatible other C++ mocking libraries

Package: libcgreen1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Cgreen Library - Unit tests and mocking framework for C and C++
 A modern unit test and mocking framework for C and C++. Cgreen features
    - fast build, clean code, highly portable
    - simple auto-discovery of tests
    - fluent, expressive and readable API
    - each test runs in isolation to prevent cross-test dependencies
    - built-in mocking for C, compatible other C++ mocking librarie
 Provides the Unittest library

Package: libcgreen1-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Cgreen Library - document
 A modern unit test and mocking framework for C and C++. Cgreen features
    - fast build, clean code, highly portable
    - simple auto-discovery of tests
    - fluent, expressive and readable API
    - each test runs in isolation to prevent cross-test dependencies
    - built-in mocking for C, compatible other C++ mocking librarie
 Provides the Unittest library document

Package: cgreen1
Section: utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Cgreen Library - Library tool
 A modern unit test and mocking framework for C and C++. Cgreen features
    - fast build, clean code, highly portable
    - simple auto-discovery of tests
    - fluent, expressive and readable API
    - each test runs in isolation to prevent cross-test dependencies
    - built-in mocking for C, compatible other C++ mocking librarie
 Provides the Unittest test tool

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
# Disable fixfilepath as it triggers build failures.
export DEB_BUILD_MAINT_OPTIONS := hardening=+all reproducible=-fixfilepath
export DEB_CFLAGS_MAINT_APPEND := -Wall -D_FORTIFY_SOURCE=2 -O1
SRC	:= $(CURDIR)
BUILD	:= $(SRC)/build
TARGET	:= $(SRC)/debian/tmp

%:
	dh $@

override_dh_auto_test:
	LD_LIBRARY_PATH="$(BUILD)/src/" dh_auto_test

override_dh_auto_configure:
	[ -d $(BUILD) ] || mkdir $(BUILD)
	cd $(BUILD) && cmake $(CURDIR) -DCMAKE_INSTALL_PREFIX="/usr" \
		-DCMAKE_SKIP_RPATH=ON \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DLIB_INSTALL_DIR=/usr/lib \
		-DCGREEN_WITH_PDF_DOCS:bool=TRUE
	touch configure-stamp


override_dh_clean:
	rm -f configure-stamp build-stamp gitrevision.h
	rm -rf $(BUILD)
	dh_clean

=== debian/tests/control ===
Tests: testsuite
Restrictions: allow-stderr
Depends: @
